'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = createCreateInstance;

var _errorhub = require('../errorhub');

var errorhub = _interopRequireWildcard(_errorhub);

var _redboxWrapper = require('./redboxWrapper');

var _redboxWrapper2 = _interopRequireDefault(_redboxWrapper);

var _destroy = require('./destroy');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

/**
 * @param {object}
 */
function createCreateInstance(PluginApi) {

	/**
  * @param {object}
  * @param {object}
  * @return {object}
  */
	return function createInstance(pluginObj, createPlugin) {
		pluginObj.plugin = createPlugin;
		pluginObj.failing = false;
		pluginObj.reload = function () {
			pluginObj.reloadData && pluginObj.reloadData();
			pluginObj.hotReload();
		};
		pluginObj.internalCall = function (name, canBeFailing, fn) {
			if (canBeFailing || pluginObj.failing === false) {
				(0, _redboxWrapper2.default)(name, pluginObj, fn);
			}
		};
		pluginObj.hotReload = function (newPlugin) {
			(0, _redboxWrapper2.default)('destroyPlugin', pluginObj, function () {
				return (0, _destroy.destroyPlugin)(pluginObj, newPlugin !== null);
			});

			pluginObj.failing = false;
			pluginObj.plugin = newPlugin === null ? null : newPlugin || pluginObj.plugin;
			pluginObj.pluginApi = undefined;
			pluginObj.api = function (name) {};
			pluginObj.instances = [];

			pluginObj.plugin && (0, _redboxWrapper2.default)('createPlugin', pluginObj, function () {
				var pluginApi = new PluginApi({
					$element: pluginObj.$element,
					pluginName: pluginObj.pluginName,
					pluginId: pluginObj.pluginId,
					pluginObj: pluginObj,
					state: pluginObj.state,
					name: pluginObj.name
				}, pluginObj.hotReload);

				pluginObj.pluginApi = pluginApi;
				pluginObj.api = pluginApi.eachApi.bind(pluginApi);
				pluginObj.pluginApi.createInstance = function (createPlugin, plugin) {
					plugin = plugin || pluginObj.pluginArgumentsObj;
					plugin = _extends({}, plugin);

					if (plugin.state) {
						plugin.state = plugin.state(createPlugin, pluginObj.instances.length);
					}

					var _pluginApi = pluginApi.spawn({
						$element: plugin.$element || pluginObj.$element,
						pluginName: pluginObj.pluginName,
						pluginId: pluginObj.pluginId,
						pluginObj: pluginObj,
						state: plugin.state,
						name: pluginObj.name
					});

					return (0, _redboxWrapper2.default)('createInstance', _pluginApi, function () {
						var instance = createPlugin.call(_pluginApi, plugin) || {};
						pluginObj.instances.push(instance);

						return function () {
							if (pluginObj.instances.indexOf(instance) !== -1) {
								pluginObj.instances.splice(pluginObj.instances.indexOf(instance), 1);
							}

							(0, _redboxWrapper2.default)('destroyInstance', _pluginApi, function () {
								_pluginApi.destroy(false);
								(0, _destroy.destroy)(instance, false);
							});
						};
					}) || function () {};
				};

				if (pluginObj.plugin.argumentObj) {
					pluginObj.instances.push(pluginObj.plugin.call(pluginApi, pluginObj.pluginArgumentsObj || {}) || {});
				} else {
					pluginObj.instances.push(pluginObj.plugin.apply(pluginApi, pluginObj.pluginArguments || []) || {});
				}
			});
		};

		pluginObj.hotReload();
		return pluginObj;
	};
}