'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.destroyPlugin = destroyPlugin;
exports.destroy = destroy;
function destroyPlugin(_ref) {
	var _ref$instances = _ref.instances;
	var instances = _ref$instances === undefined ? [] : _ref$instances;
	var pluginApi = _ref.pluginApi;
	var partial = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

	pluginApi && pluginApi.destroy(partial);
	instances.forEach(function (instance) {
		return destroy(instance, partial);
	});
}

function destroy(instance) {
	var partial = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

	if (instance) {
		if (typeof instance.destroy === 'function') {
			instance.destroy(partial);
		} else if (_typeof(instance.destroy) === 'object' && instance.destroy.length > 0) {
			instance.destroy.forEach(function (destroy) {
				return destroy(partial);
			});
		} else if (typeof instance === 'function') {
			instance(partial);
		}
	}
}