'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.bindGlobal = bindGlobal;
exports.loadGlobal = loadGlobal;
exports.updateGlobal = updateGlobal;
exports.unloadGlobal = unloadGlobal;

var _destroy = require('../lib/destroy');

var _querySelectorAll = require('../lib/querySelectorAll');

var _querySelectorAll2 = _interopRequireDefault(_querySelectorAll);

var _resolveDataAttribute = require('../lib/resolveDataAttribute');

var _resolveDataAttribute2 = _interopRequireDefault(_resolveDataAttribute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _pluginsGlobal = {};
var _loadedGlobal = {};

/**
 * @param {string}
 * @param {function}
 */
function bindGlobal(createInstance) {
	return function (name, plugin) {
		_pluginsGlobal[name] = plugin.default || plugin;
		return {
			plugins: function plugins() {
				return [];
			},
			hotReload: function hotReload() {},
			willDispose: function willDispose() {}
		};
	};
}

/**
 * @param {Element}
 */
function loadGlobal($dom) {
	(0, _querySelectorAll2.default)($dom, 'noscript[data-plugin]').forEach(function ($node) {
		(0, _resolveDataAttribute2.default)($node, 'data-plugin', function (_ref) {
			var pluginName = _ref.pluginName;
			var pluginId = _ref.pluginId;
			var name = _ref.name;
			var data = _ref.data;

			if (_pluginsGlobal[pluginName]) {
				_loadedGlobal[name] = _loadedGlobal[name] || _pluginsGlobal[pluginName](pluginId);
				_loadedGlobal[name].update(data);
			}
		});
	});
}

/**
 * @param {string}
 * @param {object}
 */
function updateGlobal(name, data) {
	_loadedGlobal[name] && _loadedGlobal[name].update(data[key]);
}

function unloadGlobal() {
	Object.keys(_loadedGlobal).forEach(function (key) {
		(0, _destroy.destroyPlugin)(_loadedGlobal[key]);
		delete _loadedGlobal[key];
	});
}