'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.bindInternalSelector = bindInternalSelector;
exports.loadInternalSelector = loadInternalSelector;

var _querySelectorAll = require('../lib/querySelectorAll');

var _querySelectorAll2 = _interopRequireDefault(_querySelectorAll);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var internalSelector = {};

/**
 * @param {string}
 * @param {function}
 * @return {function}
 */
function bindInternalSelector(selector, fn) {
	internalSelector[selector] = internalSelector[selector] || [];

	var plugin = [fn, []];
	internalSelector[selector].push(plugin);

	return function () {
		internalSelector[selector].splice(internalSelector[selector].indexOf(plugin), 1);
	};
}

/**
 * @param {Element}
 * @param {function}
 * @param {object}
 */
function loadInternalSelector($dom, options) {
	Object.keys(internalSelector).forEach(function (selector) {
		(0, _querySelectorAll2.default)($dom, selector).forEach(function ($node) {
			internalSelector[selector].forEach(function (_ref) {
				var _ref2 = _slicedToArray(_ref, 2);

				var fn = _ref2[0];
				var $nodeList = _ref2[1];

				if ($nodeList.indexOf($node) === -1) {
					$nodeList.push($node);
					fn($node, _extends({}, options));
				}
			});
		});
	});
}